/* 
Simple Graphical Timer Class

While countdown is active we show large exploding numbers on the screen. 
Provides own render method and digits from texture file.

*/
#pragma once

#include "TimeFunctions.h"
#include <GL\freeglut.h>
#include <SOIL.h>

class Countdown
{
public:
	Countdown();
	~Countdown(void);

	// draws countdown animation with large exploding digits
	void draw(float window_aspect);
	// start the timer, timeout has to be set in milliseconds
	void start(unsigned int timeout);
	// 
	bool hasElapsed();

private:
	// timer invocation time 
	clock_t StartTime;
	// user defined timeout
	unsigned int TimeOut;

	// static array of digits (texture ids)
	static GLuint Digits[10];
	static bool TexturesLoaded;

	// loads digits from texture file
	void loadTextures();
};

