#include "FileHandling.h"



// shows a open dialog box and returns the file name as char array
std::string FileHandling::open(const char* filter, const char* window_name)
{
	// we try to find the main window
	HWND hwnd = FindWindow(NULL, window_name);

	// copied from msdn lib
	OPENFILENAME ofn;       // common dialog box structure
	char szFile[512];       // buffer for file name
		
	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFile = szFile;
	// Set lpstrFile[0] to '\0' so that GetOpenFileName does not 
	// use the contents of szFile to initialize itself.
	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = filter;
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	ofn.hwndOwner = hwnd;

	// Display the Open dialog box. 
	if (GetOpenFileName(&ofn))
	{
		return std::string(ofn.lpstrFile);
	}
	else return "";
}


std::string FileHandling::save(const char* filter, const char* window_name)
{
	// we try to find the main window
	HWND hwnd = FindWindow(NULL, window_name);

	// copied from msdn lib
	OPENFILENAME ofn;       // common dialog box structure
	char szFile[512];       // buffer for file name
		
	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFile = szFile;
	// Set lpstrFile[0] to '\0' so that GetSaveFileName does not 
	// use the contents of szFile to initialize itself.
	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = filter;
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST;
	ofn.hwndOwner = hwnd;

	// Display the Save dialog box. 
	if (GetSaveFileName(&ofn))
	{
		return std::string(ofn.lpstrFile);
	}
	else return "";
}