#include "SkeletonAnimation.h"


SkeletonAnimation::SkeletonAnimation(void)
{
	Currentframe = 0;
}


SkeletonAnimation::~SkeletonAnimation(void)
{
}

unsigned int SkeletonAnimation::getSize()
{
	return SkeletonList.size();
}


void SkeletonAnimation::addFrame(NUI_SKELETON_DATA data)
{
	SkeletonList.push_back(data);
}

// increments the frame counter and returns the current frame
NUI_SKELETON_DATA SkeletonAnimation::getNextFrame()
{
	Currentframe = Currentframe % SkeletonList.size() + 1; 
	return SkeletonList[Currentframe-1];

}

NUI_SKELETON_DATA SkeletonAnimation::getFrame(int index)
{
	return SkeletonList[index]; // TODO: Check array boundaries!
}

void  SkeletonAnimation::saveAnimation(std::ofstream &open_file)
{
	// save the skeleton count
	int nr_of_skeletons = SkeletonList.size();
	open_file.write( (char*) &nr_of_skeletons, sizeof(int));

	// reset the animation so we can save the data from the very beginning
	resetAnimation();

	for (int i = 0; i < nr_of_skeletons; i++)
	{
		// let's save all the skeleton positions in the skeleton list
		NUI_SKELETON_DATA temp = getNextFrame();

		for (int j = 0; j < 20; j++) // there are 20 coordinate positions in one skeleton
		{
			float x = temp.SkeletonPositions[j].x;
			float y = temp.SkeletonPositions[j].y;
			float z = temp.SkeletonPositions[j].z;

			open_file.write( (char*) &x, sizeof(float));
			open_file.write( (char*) &y, sizeof(float));
			open_file.write( (char*) &z, sizeof(float));
		}
	}
}

void  SkeletonAnimation::loadAnimation(std::ifstream &open_file)
{
	// clear all frames
	SkeletonList.clear();

	// read the size of the animation
	int nr_of_skeletons;
	open_file.read((char *) &nr_of_skeletons, sizeof(float));

	// iterate over skeleton frames
	for (int i = 0; i < nr_of_skeletons; i++)
	{
			NUI_SKELETON_DATA temp;

			for (int j = 0; j < 20; j++) // there are 20 coordinate positions in one skeleton
			{
				float x = temp.SkeletonPositions[j].x;
				float y = temp.SkeletonPositions[j].y;
				float z = temp.SkeletonPositions[j].z;

				open_file.read( (char*) &(temp.SkeletonPositions[j].x), sizeof(float));
				open_file.read( (char*) &(temp.SkeletonPositions[j].y), sizeof(float));
				open_file.read( (char*) &(temp.SkeletonPositions[j].z), sizeof(float));
			}
			SkeletonList.push_back(temp);
	}
}