/*
Simple Class to provide skeleton animations

*/
#pragma once

#include <windows.h> //we have to include windows.h first. otherwise there are thousands of compiler errors when including nuiapi.h
#include <NuiApi.h>
#include <vector>
#include <fstream>
#include <iostream>

class SkeletonAnimation
{
public:
	
	SkeletonAnimation(void);
	~SkeletonAnimation(void);
	
	// returns number of frames
	unsigned int getSize();
	// adds a skeleton frame at the end of existing animation
	void addFrame(NUI_SKELETON_DATA data);
	// returns specific frame of animation
	NUI_SKELETON_DATA getFrame(int index);
	// returns the next skeleton frame (and sets the current frame)
	NUI_SKELETON_DATA getNextFrame();

	// resets the animation
	void resetAnimation() {Currentframe = 0;};
	// file handling
	void  saveAnimation(std::ofstream &open_file);
	void  loadAnimation(std::ifstream &open_file);

private:
	// list of skeleton frames
	std::vector<NUI_SKELETON_DATA> SkeletonList;
	// current skeleton frame
	int Currentframe;

};

