#include "TimeFunctions.h"

namespace TimeFunctions
{
	clock_t TimeFunctions::getTime()
	{
		FILETIME ft;
 
		unsigned __int64 temp = 0;
	
		GetSystemTimeAsFileTime(&ft);
 
		// The GetSystemTimeAsFileTime returns the number of 100 nanosecond 
		// intervals since Jan 1, 1601 in a structure. Copy the high and low bits
		// in the 64 bit temp, shift it left by 32 then "or" in the low 32 bits.
		temp |= ft.dwHighDateTime;
		temp <<= 32;
		temp |= ft.dwLowDateTime;
 
		// Convert to milliseconds by dividing by 10.000
		temp /= 10000;
 
		return (clock_t) temp;
	}
}