/*
This tool provides inking of strokes invoked by closed right hand. Actual color is determined by color picker tool.

*/
#pragma once
#include "Tool.h"
#include "KinectPointer.h"
#include "Kinect Test\Stroke.h"
#include "Tools\Colorpicker.h"
#include "UndoRedoManager.h"

// struct to provide undo information
struct InkInfo
{
	int StrokeID;
	math::Vec3f color;
};


class Ink2D : public Tool
{
public:

	Ink2D(std::vector<Stroke>* strokes, int* selected_stroke_id);
	~Ink2D();

	void updateLeftHandInput(Pose &pose); 
	void updateRightHandInput(Pose &pose);
	void updateBothHandInput(Pose &pose); 

	void update(Pose &pose);
	void render();
	void undo();
	void redo();

	int getTextureID(){return TextureID;};

private:
	// pointer to stroke list
	std::vector<Stroke>* Strokes;
	// we need to know the currently selected stroke id
	int* SelectedStrokeID;
	
	// undo/redo lists
	std::vector<InkInfo> UndoList;
	std::vector<InkInfo> RedoList;
	// tool icon texture
	int TextureID;
};