/*
Abstract Tool Class
*/
#pragma once

#include "Pose.h"
#include "math\Vec3f.h"


class Tool
{
public:
	Tool(void);
	virtual ~Tool(void);

	// update methods for active input
	virtual void updateLeftHandInput(Pose &pose) = 0;
	virtual void updateRightHandInput(Pose &pose) = 0;
	virtual void updateBothHandInput(Pose &pose) = 0;
	// update method for passive input
	virtual void update(Pose &pose) = 0;

	// render the tool tip
	virtual void render() = 0;

	virtual void undo() = 0;
	virtual void redo() = 0;

	// returns the texture id for tool icon
	virtual int getTextureID() = 0;
};

