#include "UndoRedoManager.h"

std::vector<Tool*> UndoRedoManager::UndoList;
std::vector<Tool*> UndoRedoManager::RedoList;


void UndoRedoManager::checkIn(Tool* tool)
{
	UndoList.push_back(tool);
	RedoList.clear();
}

void UndoRedoManager::undo()
{
	if(UndoList.size() > 0)
	{
		// copy the information into the redo list...
		RedoList.push_back(UndoList.back());
		//...and engage the tool
		UndoList.back()->undo();
		// pop the undo element
		UndoList.pop_back();
	}
}

void UndoRedoManager::redo()
{
	if(RedoList.size() > 0)
	{
		// copy the information into the undo list...
		UndoList.push_back(RedoList.back());
		//...and engage the tool
		RedoList.back()->redo();
		// pop the redo element
		RedoList.pop_back();
	}
}